﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;

using System.Xml.Linq;
using System.IO;
using System.Windows.Media.Imaging;

namespace MarsImageViewer
{
    public partial class MainPage : PhoneApplicationPage
    {
        private IEnumerable<XElement> entries;
        private int index;

        // Constructor
        public MainPage()
        {
            InitializeComponent();

            index = 0;
            getImageIDs();

        }

        private void getImageIDs()
        {
            Uri serviceUri = new Uri("https://api.sqlazureservices.com/NasaService.svc/MER/Images?missionId=1&$format=raw");
            WebClient recDownloader = new WebClient();
            recDownloader.Headers["$accountKey"] = "<Your account key>";
            recDownloader.Headers["$uniqueUserID"] = "<Your user ID>";
            recDownloader.OpenReadCompleted += new OpenReadCompletedEventHandler(recDownloader_OpenReadCompleted);
            recDownloader.OpenReadAsync(serviceUri);
        }

        private void getImage(string ID)
        {
            Uri serviceUri = new Uri("https://api.sqlazureservices.com/NasaService.svc/MER/Images/" + ID + "?$format=raw");
            WebClient imgDownloader = new WebClient();
            imgDownloader.Headers["$accountKey"] = "<Your account key>";
            imgDownloader.Headers["$uniqueUserID"] = "<Your user ID>";
            imgDownloader.OpenReadCompleted += new OpenReadCompletedEventHandler(imgDownloader_OpenReadCompleted);
            imgDownloader.OpenReadAsync(serviceUri);
        }

        private void recDownloader_OpenReadCompleted(object sender, OpenReadCompletedEventArgs e)
        {
            if (e.Error == null)
            {
                Stream responseStream = e.Result;
                XNamespace ns = "http://www.w3.org/2005/Atom";

                XElement marsStuff = XElement.Load(responseStream);
                
                entries = marsStuff.Elements(ns + "entry");

                string imageID = (string)entries.ElementAt<XElement>(index).Element(ns + "title").Value;
                getImage(imageID);
                
            }
        }

        private void imgDownloader_OpenReadCompleted(object sender, OpenReadCompletedEventArgs e)
        {
            if (e.Error == null)
            {
                Stream imageStream = e.Result;
                BitmapImage imgsrc = new BitmapImage();
                imgsrc.SetSource(imageStream);
                MarsImage.Source = imgsrc;
            }
        }

        private void appbar_BackButton_Click(object sender, EventArgs e)
        {
            if (index > 0)
            {
                index--;
                XNamespace ns = "http://www.w3.org/2005/Atom";
                string imageID = (string)entries.ElementAt<XElement>(index).Element(ns + "title").Value;                
                getImage(imageID);
            }

        }

        private void appbar_ForwardButton_Click(object sender, EventArgs e)
        {
            if ((index + 1) < entries.Count<XElement>())
            {
                index++;
                XNamespace ns = "http://www.w3.org/2005/Atom";
                string imageID = (string)entries.ElementAt<XElement>(index).Element(ns + "title").Value;
                getImage(imageID);
            }

        }
    }
}
